import es
import gamethread
import popuplib
import services

### Start Config ###
password = "nogirls"
hint = "Little Rascal's Club"
kicktime = 30 #in seconds
vips = ['STEAM_0:0:XXXXXXX', 'STEAM_0:0:XXXXXXX']
### End Config ###

info = es.AddonInfo()
info['name']        = "Club House"
info['version']     = "2.0"
info['author']      = "digital spanky"
info['url']         = "http://addons.eventscripts.com/addons/view/clubhouse"
info['description'] = "Only members know the secret password to be in the club"

es.ServerVar('clubhouse_version', info['version'], 'Club House made by digital spanky').makepublic()
validated  = set()
inprogress = set()

def load():
   if not es.exists('saycommand', password):
      es.regsaycmd(password, 'clubhouse/validate', 'Club Member')
   msg = popuplib.create('msg')
   msg.addline('Club House')
   msg.addline('--------------')
   msg.addline('Please state the club house password if you are a member.')
   msg.addline('You have %s seconds remaining to say the password.' % kicktime)
   msg.addline('Say !hint for password hint.')
   msg.addline('--------------')
   msg.addline('0. Exit')

def getAuth():
   auth_service = services.use('auth')
   auth_service.registerCapability('club_member', auth_service.ADMIN)
   
   return lambda x: auth_service.isUseridAuthorized(x, 'club_member')
   
isAuthed = getAuth()
   
def unload():
   es.unregsaycmd(password)
   popuplib.delete('msg')
   
def player_spawn(event_var):
   userid = int(event_var['userid'])
   name = es.getplayername(userid)
   if isAuthed(userid):
      admin(userid)
   elif event_var['es_steamid'] in vips:
      vip(userid)
   elif userid not in validated.union(inprogress) and event_var['es_steamid'] != "BOT":
      popuplib.send('msg', userid)
      inprogress.add(userid)
      gamethread.delayedname(kicktime, 'clubhouse_%s' % userid, kickme, userid)

def player_disconnect(event_var):
   userid = int(event_var['userid'])
   gamethread.cancelDelayed('clubhouse_%s' % userid)

   if userid in inprogress:
      inprogress.remove(userid)
   if userid in validated:
      validated.remove(userid)

def kickme(userid):
   es.server.queuecmd('kickid %s You are not a club member' % userid)
   if userid in inprogress:
      inprogress.remove(userid)

def validate():
   userid = es.getcmduserid()
   name = es.getplayername(userid)
   validated.add(userid)
   es.tell(userid, '#green', 'Welcome back member %s.'% name)
   gamethread.cancelDelayed('clubhouse_%s' % userid)

def player_say(event_var):
    text = event_var['text']
    userid = int(event_var['userid'])
    if userid not in validated:
        if text == "!hint":
            es.tell(userid, '#multi', '#lightgreenThe hint is: #default%s'% hint)
        else:
            es.tell(userid, '#lightgreen', 'Invalid Password')

def vip(userid):
   name = es.getplayername(userid)
   if userid not in validated:
      validated.add(userid)
      es.tell(userid, '#green', 'Welcome back VIP %s'% name)

def admin(userid):
   name = es.getplayername(userid)
   if userid not in validated:
      validated.add(userid)
      es.tell(userid, '#green', 'Welcome back admin %s'% name)
